SystemOrganization addCategory: #TusLibros!

TestCase subclass: #ShoppingCartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ShoppingCartTest commentStamp: '<historical>' prior: 0!
A ShoppingCartTest is a test class for testing the behavior of ShoppingCart!

!ShoppingCartTest methodsFor: '2-Publisher' stamp: 'JuanEdi 5/27/2013 21:55'!
testCartForCustomerWithoutPreviousOneShouldBeEmpty

	self assert: true.! !

!ShoppingCartTest methodsFor: '1-Shopping cart' stamp: 'JuanEdi 5/27/2013 21:38'!
testCartShouldBeEmptyAfterCreation

	self assert: (ShoppingCart newWithCatalog: #('123')) isEmpty.! !

!ShoppingCartTest methodsFor: '1-Shopping cart' stamp: 'JuanEdi 5/27/2013 21:38'!
testShouldContainBookAfterAddingItToACart
	| cart |
	cart := ShoppingCart newWithCatalog: #('123').
	cart add: 2 copiesOf: '123'.
	self assert: (cart copiesOf: '123') = 2.! !

!ShoppingCartTest methodsFor: '1-Shopping cart' stamp: 'JuanEdi 5/27/2013 21:29'!
testShouldOnlyAcceptExistingBooks

	| cart |
	
	cart := ShoppingCart newWithCatalog: #('123').
	self should: [ cart add: 1 copiesOf: 'InexistentBook' ] raise: Error.
	! !

!ShoppingCartTest methodsFor: '1-Shopping cart' stamp: 'JuanEdi 5/27/2013 21:39'!
testShouldUpdateBookOrderCountAfterAddingMoreCopies
	| cart |
	cart := ShoppingCart newWithCatalog: #('123').
	cart add: 2 copiesOf: '123'.
	cart add: 3 copiesOf: '123'.
	self assert: (cart copiesOf: '123') = 5.! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalog books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:30'!
newWithCatalog: aBookCatalog 
	
	^ self new initializeWithCatalog: aBookCatalog.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:33'!
add: aNumber copiesOf: anISBN 
	| currentCopies |
	
	self validateCatalogContainsBook: anISBN.
		
	currentCopies := books at: anISBN ifAbsent: 0.
	books at: anISBN put: (currentCopies + aNumber).! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:04'!
copiesOf: anISBN 
	
	^ books at: anISBN.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:32'!
initializeWithCatalog: aBookCatalog 

	catalog := aBookCatalog.
	books := Dictionary new.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:02'!
isEmpty
	^ books isEmpty.! !

!ShoppingCart methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/27/2013 21:38'!
validateCatalogContainsBook: anISBN

	(catalog includes: anISBN) ifFalse: [ self error: 'Error adding book to cart: ', anISBN , ' is not in the catalog.' ]! !
